//TODO
//Air resistance is not calculated on what force the ball itself is experiencing, but rather on the vertical componen
//To fix: get sum of velocity, pass that into getAirResistance function, get result, divide it into components, change
//calculation of distance equation to loop-based equation - now it goes after time, resulting in accelerating acceleration
//it must go after velocity, and change in time. Assume no deacc and calculate new position from change in distance under
//this time span.


using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace x_y_drag
{
	/// <summary>
	/// The main winForm that shows the data. It uses BallClass.cs 
	/// </summary>
	public class Drag : System.Windows.Forms.Form
	{
		#region Declarations
		/// <summary>
		/// Where all the deklarations go
		/// </summary>
		private System.Windows.Forms.Panel Variables;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.TextBox txtInitV;
		private System.Windows.Forms.TextBox txtInitAng;
		private System.Windows.Forms.TextBox txtOutput;
		private System.Windows.Forms.TextBox txtTurnsX;
		private System.Windows.Forms.TextBox txtTurnsZ;
		private System.Windows.Forms.TextBox txtTurnsY;
		private System.Windows.Forms.TextBox txtBallR;
		private System.Windows.Forms.Button btnStart;
		private System.Windows.Forms.Button btnReset; 
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.MenuItem mnuAirResistance;
		private System.Windows.Forms.MenuItem mnuMain;
		private System.Windows.Forms.MenuItem mnuReset;
		private System.Windows.Forms.MenuItem mnuQuit;
		private System.Windows.Forms.MenuItem mnuOptions;
		private System.Windows.Forms.TextBox txtC_d;
		private System.Windows.Forms.TextBox txtBallM;
		private System.Windows.Forms.TextBox txtSimTime;
		private System.Windows.Forms.Label lblTime;
		private System.Windows.Forms.TextBox txtTime;
		private System.Windows.Forms.Label lblRenolds;
		private System.Windows.Forms.TextBox txtRenolds;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Button btnCalculateRenolds;

		private double g = -9.815; // m s^-2

		#endregion
		private System.Windows.Forms.TextBox txtCoordinates;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Drag()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//here
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtInitV = new System.Windows.Forms.TextBox();
			this.txtInitAng = new System.Windows.Forms.TextBox();
			this.txtBallR = new System.Windows.Forms.TextBox();
			this.txtTurnsX = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.Variables = new System.Windows.Forms.Panel();
			this.txtC_d = new System.Windows.Forms.TextBox();
			this.label13 = new System.Windows.Forms.Label();
			this.txtBallM = new System.Windows.Forms.TextBox();
			this.label12 = new System.Windows.Forms.Label();
			this.txtSimTime = new System.Windows.Forms.TextBox();
			this.label10 = new System.Windows.Forms.Label();
			this.txtTurnsZ = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.txtTurnsY = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuMain = new System.Windows.Forms.MenuItem();
			this.mnuReset = new System.Windows.Forms.MenuItem();
			this.mnuQuit = new System.Windows.Forms.MenuItem();
			this.mnuOptions = new System.Windows.Forms.MenuItem();
			this.mnuAirResistance = new System.Windows.Forms.MenuItem();
			this.btnStart = new System.Windows.Forms.Button();
			this.txtOutput = new System.Windows.Forms.TextBox();
			this.txtCoordinates = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.btnReset = new System.Windows.Forms.Button();
			this.lblRenolds = new System.Windows.Forms.Label();
			this.lblTime = new System.Windows.Forms.Label();
			this.txtTime = new System.Windows.Forms.TextBox();
			this.txtRenolds = new System.Windows.Forms.TextBox();
			this.btnCalculateRenolds = new System.Windows.Forms.Button();
			this.label14 = new System.Windows.Forms.Label();
			this.Variables.SuspendLayout();
			this.SuspendLayout();
			// 
			// txtInitV
			// 
			this.txtInitV.Location = new System.Drawing.Point(160, 0);
			this.txtInitV.Name = "txtInitV";
			this.txtInitV.Size = new System.Drawing.Size(96, 20);
			this.txtInitV.TabIndex = 1;
			this.txtInitV.Text = "20";
			// 
			// txtInitAng
			// 
			this.txtInitAng.Location = new System.Drawing.Point(160, 24);
			this.txtInitAng.Name = "txtInitAng";
			this.txtInitAng.Size = new System.Drawing.Size(96, 20);
			this.txtInitAng.TabIndex = 2;
			this.txtInitAng.Text = "45";
			// 
			// txtBallR
			// 
			this.txtBallR.Location = new System.Drawing.Point(160, 48);
			this.txtBallR.Name = "txtBallR";
			this.txtBallR.Size = new System.Drawing.Size(96, 20);
			this.txtBallR.TabIndex = 3;
			this.txtBallR.Text = "65,6";
			// 
			// txtTurnsX
			// 
			this.txtTurnsX.Enabled = false;
			this.txtTurnsX.Location = new System.Drawing.Point(160, 96);
			this.txtTurnsX.Name = "txtTurnsX";
			this.txtTurnsX.Size = new System.Drawing.Size(96, 20);
			this.txtTurnsX.TabIndex = 4;
			this.txtTurnsX.Text = "0";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 5);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(128, 16);
			this.label2.TabIndex = 5;
			this.label2.Text = "Initial v[m/s]";
			// 
			// Variables
			// 
			this.Variables.Controls.Add(this.txtC_d);
			this.Variables.Controls.Add(this.label13);
			this.Variables.Controls.Add(this.txtBallM);
			this.Variables.Controls.Add(this.label12);
			this.Variables.Controls.Add(this.txtSimTime);
			this.Variables.Controls.Add(this.label10);
			this.Variables.Controls.Add(this.txtTurnsZ);
			this.Variables.Controls.Add(this.label6);
			this.Variables.Controls.Add(this.txtTurnsY);
			this.Variables.Controls.Add(this.label5);
			this.Variables.Controls.Add(this.label4);
			this.Variables.Controls.Add(this.label3);
			this.Variables.Controls.Add(this.label1);
			this.Variables.Controls.Add(this.label2);
			this.Variables.Controls.Add(this.txtInitV);
			this.Variables.Controls.Add(this.txtInitAng);
			this.Variables.Controls.Add(this.txtBallR);
			this.Variables.Controls.Add(this.txtTurnsX);
			this.Variables.Location = new System.Drawing.Point(8, 8);
			this.Variables.Name = "Variables";
			this.Variables.Size = new System.Drawing.Size(264, 216);
			this.Variables.TabIndex = 6;
			this.Variables.Tag = "";
			// 
			// txtC_d
			// 
			this.txtC_d.Location = new System.Drawing.Point(160, 192);
			this.txtC_d.Name = "txtC_d";
			this.txtC_d.Size = new System.Drawing.Size(96, 20);
			this.txtC_d.TabIndex = 18;
			this.txtC_d.Text = "0,4";
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(8, 197);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(100, 16);
			this.label13.TabIndex = 17;
			this.label13.Text = "Drag coefficient";
			// 
			// txtBallM
			// 
			this.txtBallM.Location = new System.Drawing.Point(160, 72);
			this.txtBallM.Name = "txtBallM";
			this.txtBallM.Size = new System.Drawing.Size(96, 20);
			this.txtBallM.TabIndex = 16;
			this.txtBallM.Text = "0,0395";
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(8, 77);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(100, 16);
			this.label12.TabIndex = 15;
			this.label12.Text = "Mass of ball [kg]";
			// 
			// txtSimTime
			// 
			this.txtSimTime.Location = new System.Drawing.Point(160, 168);
			this.txtSimTime.Name = "txtSimTime";
			this.txtSimTime.Size = new System.Drawing.Size(96, 20);
			this.txtSimTime.TabIndex = 14;
			this.txtSimTime.Text = "3300";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(8, 173);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(136, 16);
			this.label10.TabIndex = 13;
			this.label10.Text = "Sim. time span [ms]";
			// 
			// txtTurnsZ
			// 
			this.txtTurnsZ.Location = new System.Drawing.Point(160, 144);
			this.txtTurnsZ.Name = "txtTurnsZ";
			this.txtTurnsZ.Size = new System.Drawing.Size(96, 20);
			this.txtTurnsZ.TabIndex = 12;
			this.txtTurnsZ.Text = "40";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 149);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(144, 16);
			this.label6.TabIndex = 11;
			this.label6.Text = "Turns/s,  around z-axis [rps]";
			// 
			// txtTurnsY
			// 
			this.txtTurnsY.Enabled = false;
			this.txtTurnsY.Location = new System.Drawing.Point(160, 120);
			this.txtTurnsY.Name = "txtTurnsY";
			this.txtTurnsY.Size = new System.Drawing.Size(96, 20);
			this.txtTurnsY.TabIndex = 10;
			this.txtTurnsY.Text = "0";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 125);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(142, 16);
			this.label5.TabIndex = 9;
			this.label5.Text = "Turns/s, around y-axis [rps]";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 101);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(144, 16);
			this.label4.TabIndex = 8;
			this.label4.Text = "Turns/s, around x-axis [rps]";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 53);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(136, 16);
			this.label3.TabIndex = 7;
			this.label3.Text = "Radius of ball [mm]";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 29);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(152, 16);
			this.label1.TabIndex = 6;
			this.label1.Text = "Initial angle [degrees]";
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 532);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(824, 16);
			this.statusBar1.TabIndex = 7;
			this.statusBar1.Text = "Here you will be able to view messages... It\'s the statusbar!";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuMain,
																					  this.mnuOptions});
			// 
			// mnuMain
			// 
			this.mnuMain.Index = 0;
			this.mnuMain.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuReset,
																					this.mnuQuit});
			this.mnuMain.Text = "Main";
			// 
			// mnuReset
			// 
			this.mnuReset.Index = 0;
			this.mnuReset.Text = "Reset";
			this.mnuReset.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// mnuQuit
			// 
			this.mnuQuit.Index = 1;
			this.mnuQuit.Text = "Quit";
			this.mnuQuit.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// mnuOptions
			// 
			this.mnuOptions.Index = 1;
			this.mnuOptions.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.mnuAirResistance});
			this.mnuOptions.Text = "Options";
			// 
			// mnuAirResistance
			// 
			this.mnuAirResistance.Checked = true;
			this.mnuAirResistance.Index = 0;
			this.mnuAirResistance.Text = "Air resistance";
			this.mnuAirResistance.Click += new System.EventHandler(this.mnuAirResistance_Click);
			// 
			// btnStart
			// 
			this.btnStart.Location = new System.Drawing.Point(8, 274);
			this.btnStart.Name = "btnStart";
			this.btnStart.Size = new System.Drawing.Size(264, 23);
			this.btnStart.TabIndex = 8;
			this.btnStart.Text = "Accuire data";
			this.btnStart.Click += new System.EventHandler(this.btnStart_Click);
			// 
			// txtOutput
			// 
			this.txtOutput.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtOutput.Location = new System.Drawing.Point(8, 336);
			this.txtOutput.Multiline = true;
			this.txtOutput.Name = "txtOutput";
			this.txtOutput.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtOutput.Size = new System.Drawing.Size(264, 176);
			this.txtOutput.TabIndex = 9;
			this.txtOutput.Text = "";
			// 
			// txtCoordinates
			// 
			this.txtCoordinates.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtCoordinates.Location = new System.Drawing.Point(280, 24);
			this.txtCoordinates.MaxLength = 500000;
			this.txtCoordinates.Multiline = true;
			this.txtCoordinates.Name = "txtCoordinates";
			this.txtCoordinates.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtCoordinates.Size = new System.Drawing.Size(464, 488);
			this.txtCoordinates.TabIndex = 10;
			this.txtCoordinates.Text = "";
			this.txtCoordinates.DoubleClick += new System.EventHandler(this.txtCoordinates_DoubleClick);
			// 
			// label7
			// 
			this.label7.Font = new System.Drawing.Font("Arial Narrow", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label7.Location = new System.Drawing.Point(280, 8);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(80, 16);
			this.label7.TabIndex = 11;
			this.label7.Text = "x & y & z";
			// 
			// btnReset
			// 
			this.btnReset.Location = new System.Drawing.Point(8, 305);
			this.btnReset.Name = "btnReset";
			this.btnReset.Size = new System.Drawing.Size(264, 23);
			this.btnReset.TabIndex = 14;
			this.btnReset.Text = "Reset all";
			this.btnReset.Click += new System.EventHandler(this.btnReset_Click);
			// 
			// lblRenolds
			// 
			this.lblRenolds.Location = new System.Drawing.Point(144, 256);
			this.lblRenolds.Name = "lblRenolds";
			this.lblRenolds.Size = new System.Drawing.Size(93, 16);
			this.lblRenolds.TabIndex = 16;
			// 
			// lblTime
			// 
			this.lblTime.Font = new System.Drawing.Font("Arial Narrow", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTime.Location = new System.Drawing.Point(760, 8);
			this.lblTime.Name = "lblTime";
			this.lblTime.Size = new System.Drawing.Size(32, 16);
			this.lblTime.TabIndex = 17;
			this.lblTime.Text = "time";
			// 
			// txtTime
			// 
			this.txtTime.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtTime.Location = new System.Drawing.Point(752, 24);
			this.txtTime.Multiline = true;
			this.txtTime.Name = "txtTime";
			this.txtTime.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtTime.Size = new System.Drawing.Size(64, 488);
			this.txtTime.TabIndex = 18;
			this.txtTime.Text = "";
			// 
			// txtRenolds
			// 
			this.txtRenolds.Location = new System.Drawing.Point(144, 232);
			this.txtRenolds.Name = "txtRenolds";
			this.txtRenolds.Size = new System.Drawing.Size(72, 20);
			this.txtRenolds.TabIndex = 19;
			this.txtRenolds.Text = "35";
			// 
			// btnCalculateRenolds
			// 
			this.btnCalculateRenolds.Location = new System.Drawing.Point(222, 234);
			this.btnCalculateRenolds.Name = "btnCalculateRenolds";
			this.btnCalculateRenolds.Size = new System.Drawing.Size(18, 16);
			this.btnCalculateRenolds.TabIndex = 20;
			this.btnCalculateRenolds.Text = ">";
			this.btnCalculateRenolds.Click += new System.EventHandler(this.btnCalculateRenolds_Click);
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(16, 231);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(120, 27);
			this.label14.TabIndex = 21;
			this.label14.Text = "Calc. renolds number Velocity (radius above):";
			// 
			// Drag
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(824, 548);
			this.Controls.Add(this.label14);
			this.Controls.Add(this.btnCalculateRenolds);
			this.Controls.Add(this.txtRenolds);
			this.Controls.Add(this.txtTime);
			this.Controls.Add(this.lblTime);
			this.Controls.Add(this.lblRenolds);
			this.Controls.Add(this.btnReset);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.txtCoordinates);
			this.Controls.Add(this.txtOutput);
			this.Controls.Add(this.btnStart);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.Variables);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Menu = this.mainMenu1;
			this.MinimumSize = new System.Drawing.Size(832, 584);
			this.Name = "Drag";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Drag data generator";
			this.Variables.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Drag());
		}


		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			txtOutput.Text += "Exiting application..." + System.Environment.NewLine;
			Application.Exit();
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			txtOutput.Text += "Resetting variables..." + System.Environment.NewLine;
			clearAll();
		}

		private void btnStart_Click(object sender, System.EventArgs e)
		{
			wO("Initiating the ball object & setting parameters...");
			Ball b = new Ball(Convert.ToDouble(txtInitV.Text), 
						Convert.ToDouble(txtInitAng.Text)*(Math.PI/180));
			b._X = 0; 
			b._Y = 0; 
			b._Z = 0;
			b.Mass = Convert.ToDouble(txtBallM.Text);
			b.Radius = Convert.ToDouble(txtBallR.Text)/1000;
			b.C_d = Convert.ToDouble(txtC_d.Text);									//get this experimentally!!
			b.XAngVelocity = Convert.ToDouble(txtTurnsX.Text)*2*Math.PI; //w = 2PI * n (rpm: w = [2*PI*n]/60)
			b.YAngVelocity = Convert.ToDouble(txtTurnsY.Text)*2*Math.PI;
			b.ZAngVelocity = Convert.ToDouble(txtTurnsZ.Text)*2*Math.PI; //perpendicular to normal flight path

			wO("Projection angle: " + txtInitAng.Text + " degrees");
			wO("Timespan: " + txtSimTime.Text + " milliseconds");
			wO("Initial velocity: " + Math.Round(b.GetVelocity(), 2).ToString() + " m/s");
			wO("Initial horizontal velocity: " + Math.Round(b.XVelocity, 2).ToString() + " m/s");
			wO("Initial vertical velocity: " + Math.Round(b.YVelocity, 2).ToString() + " m/s");
			wO("Ball radius: " + txtBallR.Text + " mm");
			wO("Ball mass: " + txtBallM.Text + " kg");
			wO("Z-axis spin: " + txtTurnsZ.Text + " rps");

			if (mnuAirResistance.Checked) wO("Drag is on"); 
			else wO("Drag is off!");

			wO("Starting simulation...");

			double end = Convert.ToDouble(txtSimTime.Text)/1000; 
			double jump = 0.008; //and step

			double xOld, yOld, zOld;
			double xDrag, yDrag, zDrag; //Forces
			double xMagnus, yMagnus, zMagnus;
			double theta;

			writeC("X-pos:\tY-pos:\tZ-pos:\tDrag-x\tDrag-y:\tX-vel\tY-vel");
			writeT("Time");
			for (double step=0; step < end; step += jump)
			{
				xOld = b._X; //get old value
				b._X += b.XVelocity*jump; //vt = d
				//now give it a new velocity and calculate the horizontal component of drag.
				theta = Math.Atan(b.YVelocity/b.XVelocity);
				xDrag = b.GetDrag()*Math.Cos(theta);
				xMagnus = b.GetMagnusApprox()*Math.Cos(Math.PI - (theta+Math.PI/2));
				//the drag de-acc and the magnus de-acc for 'step' amount of time
				b.XVelocity = (b._X - xOld)/jump + ((xDrag + xMagnus)/b.Mass)*jump; 
				
				//no magnus
//				xDrag = b.GetDrag()*Math.Cos(Math.Atan(b.YVelocity/b.XVelocity));
//				b.XVelocity = (b._X - xOld)/jump + (xDrag/b.Mass)*jump; //the drag de-acc for 'step' amount of time

				yOld = b._Y;
				b._Y += b.YVelocity*jump;
				yDrag = b.GetDrag()*Math.Sin(theta);
				yMagnus = b.GetMagnusApprox()*Math.Sin(Math.PI - (theta+Math.PI/2));
				//if the YVelocity is negative, then angle is negative, and drag * angle is positive. 
				//Hence a positive amount is added to the negative speed (downwards) and hence decreasing fall speed
				//g is negative
				b.YVelocity = (b._Y - yOld)/jump + (g + ((yDrag + yMagnus)/b.Mass))*jump;
				
				//no magnus
//				yDrag = b.GetDrag()*Math.Sin(Math.Atan(b.YVelocity/b.XVelocity));
//				b.YVelocity = (b._Y - yOld)/jump + (g + (yDrag/b.Mass))*jump;
				
				writeC(Math.Round(b._X, 4).ToString() + "\t" 
					+ Math.Round(b._Y, 4).ToString() + "\t"
					+ Math.Round(b._Z, 4).ToString() + "\t"
					+ Math.Round(xDrag, 4).ToString() + "\t"
					+ Math.Round(yDrag, 4).ToString() + "\t"
					+ Math.Round(b.XVelocity, 4).ToString() + "\t"
					+ Math.Round(b.YVelocity, 4).ToString());
				writeT(Math.Round(step,3).ToString());
			}
			wO("Simulation ended");
		}		
		

		private void mnuAirResistance_Click(object sender, System.EventArgs e)
		{
			if(mnuAirResistance.Checked) 
			{
				mnuAirResistance.Checked = false;
			}
			else 
			{
				mnuAirResistance.Checked = true;
			}
		}

		#region Text handling functions
		/// <summary>
		/// This is needed to clear all the fields after each go
		/// </summary>
		private void btnReset_Click(object sender, System.EventArgs e)
		{
			clearAll();
		}
		private void writeC(string m)
		{
			txtCoordinates.Text += m + System.Environment.NewLine;
		}
		private void writeT(string m)
		{
			txtTime.Text +=m+System.Environment.NewLine;
		}
		private void wO(string m)
		{
			txtOutput.Text += m + System.Environment.NewLine;
		}
		private void clearAll()
		{
			txtCoordinates.Text = ""; txtTime.Text = "";
			txtOutput.Text = "Output fields reset." + System.Environment.NewLine;
		}
		#endregion

		private void btnCalculateRenolds_Click(object sender, System.EventArgs e)
		{
			Ball tempBall = new Ball(); //no need for initial velocities
			tempBall.Radius = Convert.ToDouble(txtBallR.Text)/1000;
			lblRenolds.Text = Convert.ToString(Math.Round(tempBall.GetRenolds(Convert.ToDouble(txtRenolds.Text)),0));
		}

		private void txtCoordinates_DoubleClick(object sender, System.EventArgs e)
		{
			if ((Control.ModifierKeys & Keys.Shift) == Keys.Shift)
			{
				txtCoordinates.SelectionStart = 0;
				txtCoordinates.SelectionLength = txtCoordinates.Text.Length;
			}
		}

	}
}
